;Form (Dialog) Demo
;Written by Thomas A. Stevenson (wargamer)
;thomas99@phenixcable.net
;3/12/01
;Blitzbasic 1.43

;I needed a properties type dialog form for a Map drawing program
;I am creating so I wrote this.

;This is not GUI, It creates a form, and controls it.

;There are still improvements to be made but I am quite happy
;with the basic approach

;I tried to comment the code sufficiently to ensure others
;will be able to adapt it without problems, but feel free to
;write me if needed.

;Please share any new objects or other improvements

;Send me a email if you find it useful
;but feel free to use it or modify it in any manner



;Program and Screen Globals
Const  ScrnW=800, ScrnH=600 
Global ScreenImage
Global NewRoman,arial,courier
Const  LowB=256*256-1

;Mouse Globals
Global MouseImage,MousePointer,MouseCross

;Form Globals
Global Tot_obj=0,MaxDialogItems=30
Dim obj(100,8),objText$(100),Dialog(10,MaxDialogItems),DList$(100),ReturnText$(100)

;ColorSet globals
Const black=0,white=1,red=2,Green=3,Blue=4,gray=5,LtGray=6
Dim pal(10,2)
ColorDefine(0,0,0,black)
ColorDefine(255,255,255,white)
ColorDefine(255,0,0,red)
ColorDefine(0,255,0,green)
ColorDefine(0,0,255,blue)
ColorDefine(100,100,100,gray)
ColorDefine(200,200,200,LtGray)


;*********************************  Start *********************************

Graphics ScrnW,ScrnH
SetBuffer BackBuffer()
NewRoman=LoadFont("times new roman",18)
arial=LoadFont("Arial",14)
courier=LoadFont("Courier New",16)

Cls
Color 100,100,100
Rect WinX,WinY,WinW,WinH
ScreenImage=CreateImage(scrnW,scrnH)
GrabImage ScreenImage,0,0

Restore pointerdata
MouseImage=LoadMouse()


;Main ***************************************************************

sample_dialog()
End

;Functions ****************************************************
Include "Form Functions.BB"


Function sample_dialog()

	;Master container (type 0)
	;Must be first object created for dialog D !!!!
	;D,type=0,x,y,w,h,BorderColor,InsideColor,Defaultfont,border thickness
	obj_assign(1, 0,200,200,400,300,Red,green,NewRoman,2,"","")

	;Title Bar (type 9)
	;D,type=9,x,y,w,h,border/Text color,Fill color,font, style,txt$,ObjectName$
	;Only two title styles are currently supported
	obj_assign(1,9,0,0,400,20,Black,Blue,NewRoman,2,"Sample Dialog Box","TBAR")

	;Text (type 1)
	;D,type=1,x,y,(w),(h),Txt color,True=center on X,font,NA,txt$
	obj_assign(1, 1,10,30,100,20,Black,False ,NewRoman,0,"Name","")
	;note type -1 == updatable text, i.e. text is rewritten on every update
	
	;edit text box (type 6)
	;D,type=6,x,y,w,h,Txt color,fill color,font,NA,txt$,ObjectName$	
	txt$="Text to Edit"
	obj_assign(1, 6,60,30,100,20,Black,White,NewRoman,0,txt$,"EDIT")

	;button 
	;D,type=3,x,y,w,h,fillcolor,txt color,font,Pressed,txt$,ObjectName$
	obj_assign(1,3,280,270,100,20,Red,White,NewRoman,False," Exit ","EXIT")

	;radio buttons (type 5) 
	;D,type=5,x,y,w,h,Pressed,Group#,fnt,NA,tex$ to put to right of button,ObjectName$
	obj_assign(1,5,10,60, 17,17,True, 1,Arial,0,"14 Pt Arial","ARIAL")
	obj_assign(1,5,10,80, 17,17,False,1,NewRoman,0,"18 Pt Times New Roman","TIMES")
	obj_assign(1,5,10,100, 17,17,False,1,courier,0,"16 Pt Courier New","COUR")
	fnt=arial	;initial font

	;HSlider (type 7)
	Shapew=200	;initial values
	shapeh=200
	shapehand=CreateImage(400,400)	;image size equal to maxium size
	;D,type=7,x,y,w,h,True=show value at left,min,max,current,NA$,ObjectName$	
	obj_assign(1,7,60,130,100,12,True,40,400,shapew,"","WIDTH")
	obj_assign(1,7,60,150,100,12,True,40,400,shapeh,"","HEIGHT")
	;some text to go with the above
	obj_assign(1,1,10,130,100,20,Black,False ,NewRoman,0,"Width","")
	obj_assign(1,1,10,150,100,20,Black,False ,NewRoman,0,"Height","")

	;VSlider (type 8)
	R=55:	B=155:	G=25
	;D,type=8,x,y,w,h,True=show value at bottom,min,max,current,NA$,ObjectName$
	obj_assign(1,8,80,200,12,80,True,0,255,55,"","RED")
	obj_assign(1,8,120,200,12,80,True,0,255,155,"","BLUE")
	obj_assign(1,8,160,200,12,80,True,0,255,25,"","GREEN")
	;labels for Vsliders
	obj_assign(1,2,86,180,20,16,White,Red,NewRoman,True,"R","")
	obj_assign(1,2,126,180,20,16,White,Blue,NewRoman,True,"B","")
	obj_assign(1,2,166,180,20,16,White,Green,NewRoman,True,"G","")

	;right side 
	x2=240

	;Boxed Label (type 2)
	;D,type=2,x,y,w,h,Txt color,fill color,font,True=Center,txt$,ObjectName$	
	;title for following list box
	obj_assign(1,2,x2,35,140,16,black,white,NewRoman,False,"Select Fill Pattern  ","")
	Pattern=7	;initial pattern
	;listbox (type 10)
	;D,type=10,x,y,w,h,start position,current item,font,number of items,NA$,ObjectName$	
	objIndex=obj_assign(1,10,x2,50,140,80,5,Pattern,NewRoman,10,"","PATTERN")

	;listbox scrollbar (type 11)
	;a seperate object that's associated with a list box
	;D,type,x,y,w,h,slider position ,obj# of list box,slider size,pixels per item
	obj_assign(1,11,x2+143,50,12,80,0,objIndex,0,0,"","")

	;Fill scroll box list

	;create some fill patterns
	ss=36 ;full pattern size
	Phand=CreateImage(ss,ss,11)
	
	DList$(1)=" None "
	colorset(Black)
	Rect 0,0,ss,ss
	GrabImage Phand,0,0,1

	DList$(2)=" Vert Lines"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	For x=0 To ss Step 3
	 Line X,0,X,ss
	Next
	GrabImage Phand,0,0,2

	DList$(3)=" Hori Lines"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	For y=0 To ss Step 3
		Line 0,y,ss,y
	Next
	GrabImage Phand,0,0,3

	DList$(4)=" Cross-hatch "
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	For y=2 To ss Step 3
	 	Line y,0,y,ss
		Line 0,y,ss,y
	Next
	GrabImage Phand,0,0,4
	
	DList$(5)=" Cirles"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	For y=0 To ss Step 12
		For x=0 To ss Step 12
			Oval x,y,11,11,0
		Next
	Next
	GrabImage Phand,0,0,5
	
	DList$(6)=" Slant Right"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	For x=0 To ss*2 Step 3
		Line x,0,x-ss,ss
	Next
	GrabImage Phand,0,0,6
		
	DList$(7)=" Slant Left"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	For x=0 To ss*2 Step 3
		Line x-ss,0,x,ss
	Next
	GrabImage Phand,0,0,7
	
	DList$(8)=" Dots "
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	off=0
	For y=1 To ss Step 2
		off = (off+1) Mod 2
		For x=0 To ss Step 2
			Plot x+off,y
		Next 
	Next
	GrabImage Phand,0,0,8

	DList$(9)=" Checkered"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	off=0
	For y=0 To ss Step 6
		off = (off+1) Mod 2
		For x=0 To ss Step 12
			Rect x+6*off,y,6,6
		Next 
	Next
	GrabImage Phand,0,0,9
	
	DList$(10)=" Offset Ovals"
	colorset(Black)
	Rect 0,0,ss,ss
	colorset(White)
	off=0
	For y=0 To ss Step 6
		off = (off+1) Mod 2
		For x=0 To ss Step 12
			Oval x+6*off,y,6,6
		Next 
	Next
	GrabImage Phand,0,0,10


	;Dropdown listbox
	shape=1
	;all items must be placed in a string at fixed spacing
	s$=   LSet$("Oval",10)
	s$=s$+LSet$("Rectangle",10)
	s$=s$+LSet$("Triangle",10)
	;D,type=12,x,y,w,h,nItems,#characters/item,Font,current item,items$,ObjectName$
	obj_assign(1,12,x2,140,120,20,3,10,NewRoman,1,s$,"SHAPE")

	;Check Box
	shad=False
	bord=True
	;D,type=4,x,y,w,h,NA,NA,NA,True=check,Text to display at right,ObjectName$
	obj_assign(1,4,x2,170,17,17,0,0,0,shad, "Shadow","SHAD")
	obj_assign(1,4,x2,190,17,17,0,0,0,bord,"Border","BORD")

	;animated image object
	hand=CreateImage(33,33,24)
	For k=0 To 23
		x0=K*33
		colorset(Black)
		Rect x0,0,33,33
		colorset(White)
		Oval x0+2,2,30,30
		colorset(RED)
		Oval x0+2,2,30,30,0
		Line x0+16,16,x0+16+15*Sin(-K*15),16+15*Cos(-K*15)
		GrabImage hand,x0,0,k
	Next
	;D,type=13,x,y,w,h,image handle,current tile,time interval,ntiles,NA$,Optionial$
	If hand>0 Then obj_assign(1,13,10,260,w,h,hand, 0,50,24,"","")
	
	;static image example
	;hand2=LoadImage("C:\Blitz Basic\cfg\toolbar.bmp")
	;MaskImage hand2, 33,78,204
	;w=ImageWidth(hand2)
	;h=ImageHeight(hand2)
	;If hand2>0 Then obj_assign(1,13,100,240,w,h,hand2,0,0,0,"")
	

	
	;create base form image and store the handle
	SampleDialogHand=Form_Image(1)
	
	
	Repeat
		;Draw shape base on current dialog settings
		ClsColor 0,0,0
		Cls
		Color r,g,b
		Select shape
		Case 1 ;Oval
			Oval 0,0,shapew,shapeh
			Color 255,255,255
			If bord Then Oval 0,0,shapew,shapeh,0 
		Case 2	;rectangle
			Rect 0,0,shapew,shapeh
			Color 255,255,255
			If bord Then Rect 0,0,shapew,shapeh,0
		Case 3	;triangle
			x0=shapew/2
			For y=0 To shapeh
				w12= y*shapew/shapeh/2
				Line x0-w12,y,x0+w12,y
			Next
			If bord Then 
				Color 255,255,255
				Line 0,shapeh,x0,0
				Line x0,0,shapew,shapeh
				Line 0,shapeh,shapew,shapeh
			EndIf
		End Select
		;grab the basic shape
		GrabImage shapeHand,0,0
		;laydown a pattern
		TileImage Phand,0,0,Pattern
		;make the inside of the shape transparent
		MaskImage shapeHand,r,g,b
		;draw it over the pattern, which erases everything outside the shape
		DrawImage shapeHand,0,0
		;grab the filled image
		GrabImage shapeHand,0,0	
		;set the outside to transparent
		MaskImage shapeHand,0,0,0
		
		;update the screen
		ClsColor 100,100,100
		Cls
		If shad
			Color 0,0,0
			Origin 10,10
			Select shape
			Case 1 
				Oval 0,0,shapew,shapeh
			Case 2
				Rect 0,0,shapew,shapeh
			Case 3	;triangle
				x0=shapew/2
				For y=0 To shapeh
					w12= y*shapew/shapeh/2
					Line x0-w12,y,x0+w12,y
				Next
			End Select
			Origin 0,0
		EndIf
		DrawImage shapeHand,0,0
			
		Color 255,255,255
		SetFont fnt		
		Text 0,shapeh,txt$
		GrabImage screenimage,0,0
		
		;pass control to form_control
		ObjIndex=form_control(1,SampleDialogHand,screenimage)
		;form control only returns which button was pressed
		
		Select ReturnText$(ObjIndex)
		Case ""
		Case "TBAR
		Case "EXIT"
			Return
		Case "EDIT"
			txt$=objText$(ObjIndex)
		Case "ARIAL"
			fnt=arial
		Case "TIMES"
			fnt=NewRoman
		Case "COUR"
			fnt=courier
		Case "WIDTH"
			shapew=obj(ObjIndex,8)
		Case "HEIGHT"
			shapeh=obj(ObjIndex,8)
		Case "SHAPE"
			shape=obj(ObjIndex,8)
		Case "RED"
			R=obj(ObjIndex,8)
		Case "BLUE"
			B=obj(ObjIndex,8)
		Case "GREEN"
			G=obj(ObjIndex,8)
		Case "SHAD"
			shad=obj(ObjIndex,8)
		Case "BORD"
			bord=obj(ObjIndex,8)
		Case "PATTERN"
			Pattern=obj(ObjIndex,6)
		End Select
		
	Until  KeyDown(1)
	GrabImage screenimage,0,0
	SaveImage(screenimage,"FormDemo.bmp")
	
	;Noramlly the calling routine would clean-up the screen
	;and check obj() array for new values 
	
End Function